[Product Page](https://products.aspose.com/pdf/python-net/) | [Documentation](https://docs.aspose.com/pdf/python-net/) | [Demos](https://products.aspose.app/pdf/family) | [Blog](https://blog.aspose.com/categories/aspose.pdf-product-family/) | [API Reference](https://reference.aspose.com/pdf/python-net/) | [Search](https://search.aspose.com/) | [Free Support](https://forum.aspose.com/c/pdf) | [Temporary License](https://purchase.aspose.com/temporary-license)

Try our [Free Online Apps](https://products.aspose.app/pdf/applications) demonstrating some of the most popular Aspose.PDF functionality.

**Aspose.PDF for Python via .NET** is a native library that enables the developers to add PDF processing capabilities to their applications. It can be used to generate or read, convert and manipulate PDF files without the use of Adobe Acrobat. **Aspose.PDF for Python via .NET** allows to perform a range of document processing tasks such as form processing, get and set metadata information, text and page manipulation, management of annotations, add or remove bookmarks and watermarks, attachments, custom font handling and much more.
Check out the [Landing Pages](https://products.aspose.com/pdf/python-net/) of **Aspose.PDF for Python via .NET** for a more detailed description of the features and possibilities of the library.

## General PDF Features

- Supports most established PDF standards and PDF specifications.
- Ability to read & export PDFs in multiple image formats including BMP, GIF, JPEG & PNG.  
- Set basic information (e.g. author, creator) of the PDF document.
- Configure PDF Page properties (e.g. width, height, cropbox, bleedbox etc.).
- Set page numbering, bookmark level, page sizes etc.
- Ability to work with text, paragraphs, headings, hyperlinks, graphs, attachments etc.

## Supported PDF versions

**Aspose.PDF for Python via .NET** supports PDF versions 1.2, 1.3, 1.4, 1.5, 1.6, 1.7 and 2.0.

## Conversion Features

**Aspose.PDF for Python via .NET** library allows you to successfully, quickly and easily convert your PDF documents to the most popular formats and vice versa.

- Convert PDF to Word, Excel, and PowerPoint.
- Convert PDF to Images formats.
- Convert PDF file to HTML format and vice versa.
- Convert PDF to EPUB, Text, XPS, etc.
- Convert EPUB, Markdown, Text, XPS, PostScript, XML, LaTex to PDF.

## Package Features

- Add, search, extract and replace text in PDF files.
- Add/delete, extract and replace images.
- Insert, delete, split PDF pages.
- Set and get XMP metadata.
- Validate (PDF/A-1a, PDF/A-1b).
- Work with bookmarks, annotations, PDF forms, stamps, watermarks and more.

## Supported File Formats

The following table indicates the file formats that **Aspose.PDF for Python via .NET** can load and Save.

|**Format**|**Description**|**Load**|**Save**|**Remarks**|
| :- | :- | :- | :- | :- |
|[PDF](https://docs.fileformat.com/pdf/)|Portable Document Format|**Yes**|**Yes**| |
|[CGM](https://docs.fileformat.com/page-description-language/cgm/)|Computer Graphics Metafile for 2D vector graphics|**Yes**|**No**| |
|[EPUB](https://docs.fileformat.com/ebook/epub/)|Ebook file format|**Yes**|**Yes**| |
|[HTML](https://docs.fileformat.com/web/html/)|HTML Format|**Yes**|**Yes**| |
|[TeX](https://docs.fileformat.com/page-description-language/tex/)|LaTex typesetting file format|**Yes**|**Yes**| |
|[MHT](https://docs.fileformat.com/web/mhtml/)|MHTML Document|**Yes**|**No**| |
|[PCL](https://docs.fileformat.com/page-description-language/pcl/)|Printer Control Language Files|**Yes**|**No**| |
|[PS](https://docs.fileformat.com/page-description-language/ps/)|Postscript Files|**Yes**|**No**| |
|[SVG](https://docs.fileformat.com/page-description-language/svg/)|Scalable Vector Graphics (An XML-based vector image format)|**Yes**|**Yes**| |
|[XML](https://docs.fileformat.com/web/xml/)|XML Format|**Yes**|**Yes**| |
|[XPS](https://docs.fileformat.com/page-description-language/xps/)|XPS Documents|**Yes**|**Yes**| |
|[XSLFO](https://docs.fileformat.com/page-description-language/xslfo/)|XSL-FO is part of XSL file which is used for the transformation and formatting of XML data|**Yes**|**No**| |
|[MD](https://docs.fileformat.com/word-processing/md/)|Markdown Format|**Yes**|**No**| |
|[XLS](https://docs.fileformat.com/spreadsheet/xls/)|Saves the document in the Microsoft Excel SpreadSheet|**No**|**Yes**| |
|[XLSX](https://docs.fileformat.com/spreadsheet/xlsx/)|Saves the document in the Microsoft Excel 2007 format|**No**|**Yes**| |
|[PPTX](https://docs.fileformat.com/presentation/pptx/)|Saves the document in the Microsoft PowerPoint Presentations format|**No**|**Yes**| |
|[DOC](https://docs.fileformat.com/word-processing/doc/)|Saves the document in the Microsoft Word format|**No**|**Yes**| |
|[DOCX](https://docs.fileformat.com/word-processing/docx/)|Saves the document in the Microsoft Word format|**No**|**Yes**| |
|[MobiXML](https://docs.fileformat.com/ebook/mobi/)|Saves the document in eBook MobiXML Standard format|**No**|**Yes**| |
|[JPEG](https://docs.fileformat.com/image/jpeg/)|Saves the document in JPEG Format|**Yes**|**Yes**| |
|[EMF](https://docs.fileformat.com/image/emf/)|Enhanced metafile format (EMF)|**Yes**|**Yes**| |
|[PNG](https://docs.fileformat.com/image/png/)|Saves the document in PNG Format|**Yes**|**Yes**| |
|[BMP](https://docs.fileformat.com/image/bmp/)|Saves the document in BMP Format|**Yes**|**Yes**| |
|[GIF](https://docs.fileformat.com/image/gif/)|Graphic Interchange Format|**No**|**Yes**| |
|[TIFF](https://docs.fileformat.com/image/tiff/)|Saves the document as Single or Multi-Page TIFF Image|**Yes**|**Yes**| |
|[Text](https://docs.fileformat.com/word-processing/txt/)|Save the document int Text Format|**Yes**|**Yes**| |

## Platform Independence

**Aspose.PDF for Python via .NET** can be used to develop 32-bit and 64-bit Python applications for different operating systems (such as Windows and Linux) where Python 3.5 or later is installed.


## Get Started

Run ```pip install aspose-pdf``` to fetch the package. If you already have **Aspose.PDF for Python via .NET** and want to get the latest version, please run ```pip install --upgrade aspose-pdf```.

To learn more about **Aspose.PDF for Python via .NET** and explore the basic requirements and features of the library, check out the following [Aspose.PDF for Python via .NET Documentation](https://docs.aspose.com/pdf/python-net/) pages for other use cases.

## Create a PDF file from scratch in Python

In the next code snippet, we are creating a PDF document fron scratch containing the text “Hello World!”. After installing **Aspose.PDF for Python via .NET** in your environment, you can execute below code sample to see how Aspose.PDF API works. 

Below code snippet follows these steps:

1. Instantiate a Document object.
1. Add a Page to the document object.
1. Create a TextFragment object.
1. Add TextFragment to Paragraph collection of the page.
1. Save the resultant PDF document.

The following code snippet is a “Hello, World!” program to exhibit working of **Aspose.PDF for Python via .NET** API:

```python
import aspose.pdf as ap

# Initialize document object
document = ap.Document()
# Add page
page = document.pages.add()
# Initialize textfragment object
text_fragment = ap.text.TextFragment("Hello,world!")
# Add text fragment to new page
page.paragraphs.add(text_fragment)
# Save updated PDF
document.save("output.pdf")
```

## Example of converting HTML to PDF

**Aspose.PDF for Python via .NET** is a PDF manipulation API that lets you convert any existing HTML documents to PDF format. The process of converting HTML to PDF can be flexibly customized.

Below code snippet follows these steps:

1. Create an instance of the HtmlLoadOptions object.
1. Initialize Document object.
1. Save output PDF document by calling Document.Save() method.

```python
import aspose.pdf as ap
# Instantiate an object of HtmlLoadOptions
options = ap.HtmlLoadOptions()
# Convert HTML to PDF
document = ap.Document("input.html", options)
# Save PDF
document.save("output.pdf")
```

## Example of converting PDF to SVG

**Aspose.PDF for Python via .NET** supports the feature to convert SVG image to PDF format. To accomplish this requirement, the SvgSaveOptions class has been introduced into the Aspose.PDF namespace. Instantiate an object of SvgSaveOptions and pass it as a second argument to the Document.Save(..) method.

Below code snippet follows these steps:

1. Create an object of the Document class.
1. Create SvgSaveOptions object with needed settings.
1. Call the Document.Save() method and pass it SvgSaveOptions object convert the PDF document to SVG.

```python
import aspose.pdf as ap

# Open PDF document
document = ap.Document("input.pdf")

# Instantiate an object of SvgSaveOptions
saveOptions = ap.SvgSaveOptions()

# Do not compress SVG image to Zip archive
saveOptions.compress_output_to_zip_archive = False
saveOptions.treat_target_file_name_as_directory = True

# Save the output in SVG files
document.save("output.svg", saveOptions)
```

## Merge PDF Files

Merge multiple PDF into single file in Python with Aspose.PDF programmatically. PDF files are merged such that the first one is joined at the end of the other document.

Below code snippet follows these steps:

1. Open first document.
1. Open second document.
1. Add pages of second document to the first.
1. Save concatenated output file.

```python
import aspose.pdf as ap

# Open first document
document1 = ap.Document("input_1.pdf")
# Open second document
document2 = ap.Document("input_2.pdf")

# Add pages of second document to the first
document1.pages.add(document2.pages)

# Save concatenated output file
document1.save("output.pdf")
```

## Print PDF to XPS printer

You can print a PDF file to an XPS printer, or some other soft printer for that matter, using the PdfViewer class. 

Below code snippet follows these steps:


1. Create an object of the PdfViewer class.
1. Open the PDF file using the bind_pdf method.
1. Set different print settings using the PrinterSettings and PageSettings classes.
1. Set the printer_name property to the XPS or other printer.
1. Print document using the print_document_with_settings method.

```python
import aspose.pdf as ap
import aspose.pydrawing as drawing

# Create PdfViewer object
viewer = ap.facades.PdfViewer()

# Open input PDF file
viewer.bind_pdf("input.pdf")

# Set attributes for printing
# Print the file with adjusted size
viewer.auto_resize = True
# Print the file with adjusted rotation
viewer.auto_rotate = True
# Do not produce the page number dialog when printing
viewer.print_page_dialog = False

# Create objects for printer and page settings
ps = drawing.printing.PrinterSettings()
pgs = drawing.printing.PageSettings()

# Set XPS/PDF printer name
ps.printer_name = "Microsoft XPS Document Writer"
# Or set the PDF printer
# ps.printer_name = "Adobe PDF"

# Set PageSize(if required)
pgs.paper_size = drawing.printing.PaperSize("A4", 827, 1169)

# Set PageMargins(if required)
pgs.margins = drawing.printing.Margins(0, 0, 0, 0)

# Print document using printer and page settings
viewer.print_document_with_settings(pgs, ps)

# Close the PDF file after printing
viewer.close()
```

[Product Page](https://products.aspose.com/pdf/python-net/) | [Documentation](https://docs.aspose.com/pdf/python-net/) | [Demos](https://products.aspose.app/pdf/family) | [Blog](https://blog.aspose.com/categories/aspose.pdf-product-family/) | [API Reference](https://reference.aspose.com/pdf/python-net/) | [Search](https://search.aspose.com/) | [Free Support](https://forum.aspose.com/c/pdf) | [Temporary License](https://purchase.aspose.com/temporary-license)